import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { useLocation as useLocationReactRouterDOM } from 'react-router-dom';
import { debounce, isEnvironment } from '@amaui/utils';
const useLocation = props => {
  const {} = props;
  const locationReactRouterDOM = useLocationReactRouterDOM();
  const [response, setResponse] = React.useState(isEnvironment('browser') ? _objectSpread({}, window.location) : {});
  const onUpdate = React.useCallback(debounce(function () {
    let value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window.location;
    setResponse(_objectSpread({}, value));
  }, 40), []);

  // React router DOM
  React.useEffect(() => {
    onUpdate(locationReactRouterDOM);
  }, [locationReactRouterDOM]);
  React.useEffect(() => {
    if (!(isEnvironment('browser') && 'MutationObserver' in window)) return;
    const body = window.document.querySelector('body');
    let previous = window.location.href;
    const observer = new MutationObserver(() => {
      const url = window.location.href;
      if (previous !== url) {
        previous = url;
        onUpdate();
      }
    });
    observer.observe(body, {
      childList: true,
      subtree: true
    });
    return () => {
      // Clean up
      observer.disconnect();
    };
  }, []);
  return response;
};
useLocation.displayName = 'amaui-UseLocation';
export default useLocation;