"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const utils_1 = require("@amaui/utils");
const useLocation = (props) => {
    const {} = props;
    const locationReactRouterDOM = (0, react_router_dom_1.useLocation)();
    const [response, setResponse] = react_1.default.useState((0, utils_1.isEnvironment)('browser') ? Object.assign({}, window.location) : {});
    const onUpdate = react_1.default.useCallback((0, utils_1.debounce)((value = window.location) => {
        setResponse(Object.assign({}, value));
    }, 40), []);
    // React router DOM
    react_1.default.useEffect(() => {
        onUpdate(locationReactRouterDOM);
    }, [locationReactRouterDOM]);
    react_1.default.useEffect(() => {
        if (!((0, utils_1.isEnvironment)('browser') && 'MutationObserver' in window))
            return;
        const body = window.document.querySelector('body');
        let previous = window.location.href;
        const observer = new MutationObserver(() => {
            const url = window.location.href;
            if (previous !== url) {
                previous = url;
                onUpdate();
            }
        });
        observer.observe(body, { childList: true, subtree: true });
        return () => {
            // Clean up
            observer.disconnect();
        };
    }, []);
    return response;
};
useLocation.displayName = 'amaui-UseLocation';
exports.default = useLocation;
